# Get a waterfall (/docs/api/waterfalls/waterfall_get)

One waterfall: its draft definition, versions and published endpoint.

`GET /v1/waterfalls/{id}`

```json
{
  "operationId": "waterfall_get",
  "summary": "Get a waterfall",
  "description": "One waterfall: its draft definition, versions and published endpoint.",
  "tags": [
    "waterfalls"
  ],
  "security": [
    {
      "bearer": []
    }
  ],
  "parameters": [
    {
      "schema": {
        "type": "string",
        "pattern": "^wf_[a-z0-9]{8,40}$"
      },
      "required": true,
      "name": "id",
      "in": "path"
    }
  ],
  "responses": {
    "200": {
      "description": "OK",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "properties": {
              "object": {
                "type": "string",
                "enum": [
                  "waterfall"
                ]
              },
              "id": {
                "type": "string",
                "pattern": "^wf_[a-z0-9]{8,40}$"
              },
              "name": {
                "type": "string",
                "minLength": 2,
                "maxLength": 48,
                "pattern": "^[a-z0-9]+(-[a-z0-9]+)*$"
              },
              "title": {
                "type": "string",
                "minLength": 1,
                "maxLength": 80
              },
              "description": {
                "type": "string",
                "maxLength": 500
              },
              "status": {
                "type": "string",
                "enum": [
                  "draft",
                  "published",
                  "archived"
                ]
              },
              "draft": {
                "oneOf": [
                  {
                    "type": "object",
                    "properties": {
                      "kind": {
                        "type": "string",
                        "enum": [
                          "waterfall"
                        ]
                      },
                      "id": {
                        "type": "string",
                        "minLength": 1,
                        "maxLength": 40,
                        "pattern": "^[a-z0-9][a-z0-9_-]*$",
                        "default": "main"
                      },
                      "capability": {
                        "type": "string",
                        "pattern": "^[a-z]+(\\.[a-z0-9_]+)+$"
                      },
                      "steps": {
                        "type": "array",
                        "items": {
                          "oneOf": [
                            {
                              "type": "object",
                              "properties": {
                                "type": {
                                  "type": "string",
                                  "enum": [
                                    "endpoint"
                                  ]
                                },
                                "endpoint_id": {
                                  "type": "string",
                                  "minLength": 3,
                                  "maxLength": 200
                                },
                                "id": {
                                  "type": "string",
                                  "minLength": 1,
                                  "maxLength": 40,
                                  "pattern": "^[a-z0-9][a-z0-9_-]*$",
                                  "description": "Stable id; defaults to the endpoint id"
                                },
                                "timeout_ms": {
                                  "type": "integer",
                                  "minimum": 100,
                                  "maximum": 120000
                                },
                                "retries": {
                                  "type": "integer",
                                  "minimum": 0,
                                  "maximum": 5,
                                  "default": 0,
                                  "description": "Retries on 5xx and timeouts"
                                },
                                "retry_backoff_ms": {
                                  "type": "integer",
                                  "minimum": 0,
                                  "maximum": 30000,
                                  "default": 250
                                },
                                "max_cost_micro": {
                                  "type": "integer",
                                  "minimum": 0,
                                  "description": "Skip this step if its quote is above this"
                                },
                                "required_fields": {
                                  "type": "array",
                                  "items": {
                                    "type": "string",
                                    "maxLength": 80,
                                    "pattern": "^[a-z][a-z0-9_]*(\\.[a-z][a-z0-9_]*)*$"
                                  },
                                  "maxItems": 20,
                                  "default": []
                                },
                                "min_confidence": {
                                  "type": "number",
                                  "minimum": 0,
                                  "maximum": 100
                                },
                                "confidence_field": {
                                  "type": "string",
                                  "maxLength": 80,
                                  "pattern": "^[a-z][a-z0-9_]*(\\.[a-z][a-z0-9_]*)*$",
                                  "default": "confidence"
                                },
                                "prefer_verified": {
                                  "type": "boolean",
                                  "default": false
                                },
                                "continue_on_hit": {
                                  "type": "boolean",
                                  "default": false
                                },
                                "credential": {
                                  "type": "string",
                                  "enum": [
                                    "auto",
                                    "managed",
                                    "byok"
                                  ],
                                  "default": "auto"
                                },
                                "on_client_error": {
                                  "type": "string",
                                  "enum": [
                                    "continue",
                                    "fail"
                                  ],
                                  "default": "continue"
                                },
                                "when": {
                                  "anyOf": [
                                    {
                                      "type": "object",
                                      "properties": {
                                        "field": {
                                          "type": "string",
                                          "maxLength": 120,
                                          "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                        },
                                        "op": {
                                          "type": "string",
                                          "enum": [
                                            "eq",
                                            "neq",
                                            "gt",
                                            "gte",
                                            "lt",
                                            "lte",
                                            "exists",
                                            "not_exists",
                                            "non_empty",
                                            "contains",
                                            "starts_with",
                                            "ends_with",
                                            "in",
                                            "not_in"
                                          ]
                                        },
                                        "value": {
                                          "anyOf": [
                                            {
                                              "type": "string",
                                              "maxLength": 500
                                            },
                                            {
                                              "type": "number"
                                            },
                                            {
                                              "type": "boolean"
                                            },
                                            {
                                              "type": "null"
                                            },
                                            {
                                              "type": "array",
                                              "items": {
                                                "anyOf": [
                                                  {
                                                    "type": "string",
                                                    "maxLength": 500
                                                  },
                                                  {
                                                    "type": "number"
                                                  },
                                                  {
                                                    "type": "boolean"
                                                  },
                                                  {
                                                    "type": "null"
                                                  }
                                                ]
                                              },
                                              "maxItems": 50
                                            }
                                          ]
                                        }
                                      },
                                      "required": [
                                        "field",
                                        "op"
                                      ]
                                    },
                                    {
                                      "type": "object",
                                      "properties": {
                                        "all": {
                                          "type": "array",
                                          "items": {
                                            "type": "object",
                                            "properties": {
                                              "field": {
                                                "type": "string",
                                                "maxLength": 120,
                                                "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                              },
                                              "op": {
                                                "type": "string",
                                                "enum": [
                                                  "eq",
                                                  "neq",
                                                  "gt",
                                                  "gte",
                                                  "lt",
                                                  "lte",
                                                  "exists",
                                                  "not_exists",
                                                  "non_empty",
                                                  "contains",
                                                  "starts_with",
                                                  "ends_with",
                                                  "in",
                                                  "not_in"
                                                ]
                                              },
                                              "value": {
                                                "anyOf": [
                                                  {
                                                    "type": "string",
                                                    "maxLength": 500
                                                  },
                                                  {
                                                    "type": "number"
                                                  },
                                                  {
                                                    "type": "boolean"
                                                  },
                                                  {
                                                    "type": "null"
                                                  },
                                                  {
                                                    "type": "array",
                                                    "items": {
                                                      "anyOf": [
                                                        {
                                                          "type": "string",
                                                          "maxLength": 500
                                                        },
                                                        {
                                                          "type": "number"
                                                        },
                                                        {
                                                          "type": "boolean"
                                                        },
                                                        {
                                                          "type": "null"
                                                        }
                                                      ]
                                                    },
                                                    "maxItems": 50
                                                  }
                                                ]
                                              }
                                            },
                                            "required": [
                                              "field",
                                              "op"
                                            ]
                                          },
                                          "minItems": 1,
                                          "maxItems": 20
                                        }
                                      },
                                      "required": [
                                        "all"
                                      ]
                                    },
                                    {
                                      "type": "object",
                                      "properties": {
                                        "any": {
                                          "type": "array",
                                          "items": {
                                            "type": "object",
                                            "properties": {
                                              "field": {
                                                "type": "string",
                                                "maxLength": 120,
                                                "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                              },
                                              "op": {
                                                "type": "string",
                                                "enum": [
                                                  "eq",
                                                  "neq",
                                                  "gt",
                                                  "gte",
                                                  "lt",
                                                  "lte",
                                                  "exists",
                                                  "not_exists",
                                                  "non_empty",
                                                  "contains",
                                                  "starts_with",
                                                  "ends_with",
                                                  "in",
                                                  "not_in"
                                                ]
                                              },
                                              "value": {
                                                "anyOf": [
                                                  {
                                                    "type": "string",
                                                    "maxLength": 500
                                                  },
                                                  {
                                                    "type": "number"
                                                  },
                                                  {
                                                    "type": "boolean"
                                                  },
                                                  {
                                                    "type": "null"
                                                  },
                                                  {
                                                    "type": "array",
                                                    "items": {
                                                      "anyOf": [
                                                        {
                                                          "type": "string",
                                                          "maxLength": 500
                                                        },
                                                        {
                                                          "type": "number"
                                                        },
                                                        {
                                                          "type": "boolean"
                                                        },
                                                        {
                                                          "type": "null"
                                                        }
                                                      ]
                                                    },
                                                    "maxItems": 50
                                                  }
                                                ]
                                              }
                                            },
                                            "required": [
                                              "field",
                                              "op"
                                            ]
                                          },
                                          "minItems": 1,
                                          "maxItems": 20
                                        }
                                      },
                                      "required": [
                                        "any"
                                      ]
                                    },
                                    {
                                      "type": "object",
                                      "properties": {
                                        "not": {
                                          "type": "object",
                                          "properties": {
                                            "field": {
                                              "type": "string",
                                              "maxLength": 120,
                                              "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                            },
                                            "op": {
                                              "type": "string",
                                              "enum": [
                                                "eq",
                                                "neq",
                                                "gt",
                                                "gte",
                                                "lt",
                                                "lte",
                                                "exists",
                                                "not_exists",
                                                "non_empty",
                                                "contains",
                                                "starts_with",
                                                "ends_with",
                                                "in",
                                                "not_in"
                                              ]
                                            },
                                            "value": {
                                              "anyOf": [
                                                {
                                                  "type": "string",
                                                  "maxLength": 500
                                                },
                                                {
                                                  "type": "number"
                                                },
                                                {
                                                  "type": "boolean"
                                                },
                                                {
                                                  "type": "null"
                                                },
                                                {
                                                  "type": "array",
                                                  "items": {
                                                    "anyOf": [
                                                      {
                                                        "type": "string",
                                                        "maxLength": 500
                                                      },
                                                      {
                                                        "type": "number"
                                                      },
                                                      {
                                                        "type": "boolean"
                                                      },
                                                      {
                                                        "type": "null"
                                                      }
                                                    ]
                                                  },
                                                  "maxItems": 50
                                                }
                                              ]
                                            }
                                          },
                                          "required": [
                                            "field",
                                            "op"
                                          ]
                                        }
                                      },
                                      "required": [
                                        "not"
                                      ]
                                    },
                                    {
                                      "type": "object",
                                      "properties": {
                                        "all": {
                                          "type": "array",
                                          "items": {
                                            "anyOf": [
                                              {
                                                "type": "object",
                                                "properties": {
                                                  "field": {
                                                    "type": "string",
                                                    "maxLength": 120,
                                                    "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                  },
                                                  "op": {
                                                    "type": "string",
                                                    "enum": [
                                                      "eq",
                                                      "neq",
                                                      "gt",
                                                      "gte",
                                                      "lt",
                                                      "lte",
                                                      "exists",
                                                      "not_exists",
                                                      "non_empty",
                                                      "contains",
                                                      "starts_with",
                                                      "ends_with",
                                                      "in",
                                                      "not_in"
                                                    ]
                                                  },
                                                  "value": {
                                                    "anyOf": [
                                                      {
                                                        "type": "string",
                                                        "maxLength": 500
                                                      },
                                                      {
                                                        "type": "number"
                                                      },
                                                      {
                                                        "type": "boolean"
                                                      },
                                                      {
                                                        "type": "null"
                                                      },
                                                      {
                                                        "type": "array",
                                                        "items": {
                                                          "anyOf": [
                                                            {
                                                              "type": "string",
                                                              "maxLength": 500
                                                            },
                                                            {
                                                              "type": "number"
                                                            },
                                                            {
                                                              "type": "boolean"
                                                            },
                                                            {
                                                              "type": "null"
                                                            }
                                                          ]
                                                        },
                                                        "maxItems": 50
                                                      }
                                                    ]
                                                  }
                                                },
                                                "required": [
                                                  "field",
                                                  "op"
                                                ]
                                              },
                                              {
                                                "type": "object",
                                                "properties": {
                                                  "all": {
                                                    "type": "array",
                                                    "items": {
                                                      "type": "object",
                                                      "properties": {
                                                        "field": {
                                                          "type": "string",
                                                          "maxLength": 120,
                                                          "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                        },
                                                        "op": {
                                                          "type": "string",
                                                          "enum": [
                                                            "eq",
                                                            "neq",
                                                            "gt",
                                                            "gte",
                                                            "lt",
                                                            "lte",
                                                            "exists",
                                                            "not_exists",
                                                            "non_empty",
                                                            "contains",
                                                            "starts_with",
                                                            "ends_with",
                                                            "in",
                                                            "not_in"
                                                          ]
                                                        },
                                                        "value": {
                                                          "anyOf": [
                                                            {
                                                              "type": "string",
                                                              "maxLength": 500
                                                            },
                                                            {
                                                              "type": "number"
                                                            },
                                                            {
                                                              "type": "boolean"
                                                            },
                                                            {
                                                              "type": "null"
                                                            },
                                                            {
                                                              "type": "array",
                                                              "items": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  }
                                                                ]
                                                              },
                                                              "maxItems": 50
                                                            }
                                                          ]
                                                        }
                                                      },
                                                      "required": [
                                                        "field",
                                                        "op"
                                                      ]
                                                    },
                                                    "minItems": 1,
                                                    "maxItems": 20
                                                  }
                                                },
                                                "required": [
                                                  "all"
                                                ]
                                              },
                                              {
                                                "type": "object",
                                                "properties": {
                                                  "any": {
                                                    "type": "array",
                                                    "items": {
                                                      "type": "object",
                                                      "properties": {
                                                        "field": {
                                                          "type": "string",
                                                          "maxLength": 120,
                                                          "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                        },
                                                        "op": {
                                                          "type": "string",
                                                          "enum": [
                                                            "eq",
                                                            "neq",
                                                            "gt",
                                                            "gte",
                                                            "lt",
                                                            "lte",
                                                            "exists",
                                                            "not_exists",
                                                            "non_empty",
                                                            "contains",
                                                            "starts_with",
                                                            "ends_with",
                                                            "in",
                                                            "not_in"
                                                          ]
                                                        },
                                                        "value": {
                                                          "anyOf": [
                                                            {
                                                              "type": "string",
                                                              "maxLength": 500
                                                            },
                                                            {
                                                              "type": "number"
                                                            },
                                                            {
                                                              "type": "boolean"
                                                            },
                                                            {
                                                              "type": "null"
                                                            },
                                                            {
                                                              "type": "array",
                                                              "items": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  }
                                                                ]
                                                              },
                                                              "maxItems": 50
                                                            }
                                                          ]
                                                        }
                                                      },
                                                      "required": [
                                                        "field",
                                                        "op"
                                                      ]
                                                    },
                                                    "minItems": 1,
                                                    "maxItems": 20
                                                  }
                                                },
                                                "required": [
                                                  "any"
                                                ]
                                              },
                                              {
                                                "type": "object",
                                                "properties": {
                                                  "not": {
                                                    "type": "object",
                                                    "properties": {
                                                      "field": {
                                                        "type": "string",
                                                        "maxLength": 120,
                                                        "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                      },
                                                      "op": {
                                                        "type": "string",
                                                        "enum": [
                                                          "eq",
                                                          "neq",
                                                          "gt",
                                                          "gte",
                                                          "lt",
                                                          "lte",
                                                          "exists",
                                                          "not_exists",
                                                          "non_empty",
                                                          "contains",
                                                          "starts_with",
                                                          "ends_with",
                                                          "in",
                                                          "not_in"
                                                        ]
                                                      },
                                                      "value": {
                                                        "anyOf": [
                                                          {
                                                            "type": "string",
                                                            "maxLength": 500
                                                          },
                                                          {
                                                            "type": "number"
                                                          },
                                                          {
                                                            "type": "boolean"
                                                          },
                                                          {
                                                            "type": "null"
                                                          },
                                                          {
                                                            "type": "array",
                                                            "items": {
                                                              "anyOf": [
                                                                {
                                                                  "type": "string",
                                                                  "maxLength": 500
                                                                },
                                                                {
                                                                  "type": "number"
                                                                },
                                                                {
                                                                  "type": "boolean"
                                                                },
                                                                {
                                                                  "type": "null"
                                                                }
                                                              ]
                                                            },
                                                            "maxItems": 50
                                                          }
                                                        ]
                                                      }
                                                    },
                                                    "required": [
                                                      "field",
                                                      "op"
                                                    ]
                                                  }
                                                },
                                                "required": [
                                                  "not"
                                                ]
                                              }
                                            ]
                                          },
                                          "minItems": 1,
                                          "maxItems": 20
                                        }
                                      },
                                      "required": [
                                        "all"
                                      ]
                                    },
                                    {
                                      "type": "object",
                                      "properties": {
                                        "any": {
                                          "type": "array",
                                          "items": {
                                            "anyOf": [
                                              {
                                                "type": "object",
                                                "properties": {
                                                  "field": {
                                                    "type": "string",
                                                    "maxLength": 120,
                                                    "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                  },
                                                  "op": {
                                                    "type": "string",
                                                    "enum": [
                                                      "eq",
                                                      "neq",
                                                      "gt",
                                                      "gte",
                                                      "lt",
                                                      "lte",
                                                      "exists",
                                                      "not_exists",
                                                      "non_empty",
                                                      "contains",
                                                      "starts_with",
                                                      "ends_with",
                                                      "in",
                                                      "not_in"
                                                    ]
                                                  },
                                                  "value": {
                                                    "anyOf": [
                                                      {
                                                        "type": "string",
                                                        "maxLength": 500
                                                      },
                                                      {
                                                        "type": "number"
                                                      },
                                                      {
                                                        "type": "boolean"
                                                      },
                                                      {
                                                        "type": "null"
                                                      },
                                                      {
                                                        "type": "array",
                                                        "items": {
                                                          "anyOf": [
                                                            {
                                                              "type": "string",
                                                              "maxLength": 500
                                                            },
                                                            {
                                                              "type": "number"
                                                            },
                                                            {
                                                              "type": "boolean"
                                                            },
                                                            {
                                                              "type": "null"
                                                            }
                                                          ]
                                                        },
                                                        "maxItems": 50
                                                      }
                                                    ]
                                                  }
                                                },
                                                "required": [
                                                  "field",
                                                  "op"
                                                ]
                                              },
                                              {
                                                "type": "object",
                                                "properties": {
                                                  "all": {
                                                    "type": "array",
                                                    "items": {
                                                      "type": "object",
                                                      "properties": {
                                                        "field": {
                                                          "type": "string",
                                                          "maxLength": 120,
                                                          "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                        },
                                                        "op": {
                                                          "type": "string",
                                                          "enum": [
                                                            "eq",
                                                            "neq",
                                                            "gt",
                                                            "gte",
                                                            "lt",
                                                            "lte",
                                                            "exists",
                                                            "not_exists",
                                                            "non_empty",
                                                            "contains",
                                                            "starts_with",
                                                            "ends_with",
                                                            "in",
                                                            "not_in"
                                                          ]
                                                        },
                                                        "value": {
                                                          "anyOf": [
                                                            {
                                                              "type": "string",
                                                              "maxLength": 500
                                                            },
                                                            {
                                                              "type": "number"
                                                            },
                                                            {
                                                              "type": "boolean"
                                                            },
                                                            {
                                                              "type": "null"
                                                            },
                                                            {
                                                              "type": "array",
                                                              "items": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  }
                                                                ]
                                                              },
                                                              "maxItems": 50
                                                            }
                                                          ]
                                                        }
                                                      },
                                                      "required": [
                                                        "field",
                                                        "op"
                                                      ]
                                                    },
                                                    "minItems": 1,
                                                    "maxItems": 20
                                                  }
                                                },
                                                "required": [
                                                  "all"
                                                ]
                                              },
                                              {
                                                "type": "object",
                                                "properties": {
                                                  "any": {
                                                    "type": "array",
                                                    "items": {
                                                      "type": "object",
                                                      "properties": {
                                                        "field": {
                                                          "type": "string",
                                                          "maxLength": 120,
                                                          "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                        },
                                                        "op": {
                                                          "type": "string",
                                                          "enum": [
                                                            "eq",
                                                            "neq",
                                                            "gt",
                                                            "gte",
                                                            "lt",
                                                            "lte",
                                                            "exists",
                                                            "not_exists",
                                                            "non_empty",
                                                            "contains",
                                                            "starts_with",
                                                            "ends_with",
                                                            "in",
                                                            "not_in"
                                                          ]
                                                        },
                                                        "value": {
                                                          "anyOf": [
                                                            {
                                                              "type": "string",
                                                              "maxLength": 500
                                                            },
                                                            {
                                                              "type": "number"
                                                            },
                                                            {
                                                              "type": "boolean"
                                                            },
                                                            {
                                                              "type": "null"
                                                            },
                                                            {
                                                              "type": "array",
                                                              "items": {
                                                                "anyOf": [
                                                                  {
                                                                    "type": "string",
                                                                    "maxLength": 500
                                                                  },
                                                                  {
                                                                    "type": "number"
                                                                  },
                                                                  {
                                                                    "type": "boolean"
                                                                  },
                                                                  {
                                                                    "type": "null"
                                                                  }
                                                                ]
                                                              },
                                                              "maxItems": 50
                                                            }
                                                          ]
                                                        }
                                                      },
                                                      "required": [
                                                        "field",
                                                        "op"
                                                      ]
                                                    },
                                                    "minItems": 1,
                                                    "maxItems": 20
                                                  }
                                                },
                                                "required": [
                                                  "any"
                                                ]
                                              },
                                              {
                                                "type": "object",
                                                "properties": {
                                                  "not": {
                                                    "type": "object",
                                                    "properties": {
                                                      "field": {
                                                        "type": "string",
                                                        "maxLength": 120,
                                                        "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                      },
                                                      "op": {
                                                        "type": "string",
                                                        "enum": [
                                                          "eq",
                                                          "neq",
                                                          "gt",
                                                          "gte",
                                                          "lt",
                                                          "lte",
                                                          "exists",
                                                          "not_exists",
                                                          "non_empty",
                                                          "contains",
                                                          "starts_with",
                                                          "ends_with",
                                                          "in",
                                                          "not_in"
                                                        ]
                                                      },
                                                      "value": {
                                                        "anyOf": [
                                                          {
                                                            "type": "string",
                                                            "maxLength": 500
                                                          },
                                                          {
                                                            "type": "number"
                                                          },
                                                          {
                                                            "type": "boolean"
                                                          },
                                                          {
                                                            "type": "null"
                                                          },
                                                          {
                                                            "type": "array",
                                                            "items": {
                                                              "anyOf": [
                                                                {
                                                                  "type": "string",
                                                                  "maxLength": 500
                                                                },
                                                                {
                                                                  "type": "number"
                                                                },
                                                                {
                                                                  "type": "boolean"
                                                                },
                                                                {
                                                                  "type": "null"
                                                                }
                                                              ]
                                                            },
                                                            "maxItems": 50
                                                          }
                                                        ]
                                                      }
                                                    },
                                                    "required": [
                                                      "field",
                                                      "op"
                                                    ]
                                                  }
                                                },
                                                "required": [
                                                  "not"
                                                ]
                                              }
                                            ]
                                          },
                                          "minItems": 1,
                                          "maxItems": 20
                                        }
                                      },
                                      "required": [
                                        "any"
                                      ]
                                    },
                                    {
                                      "type": "object",
                                      "properties": {
                                        "not": {
                                          "anyOf": [
                                            {
                                              "type": "object",
                                              "properties": {
                                                "field": {
                                                  "type": "string",
                                                  "maxLength": 120,
                                                  "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                },
                                                "op": {
                                                  "type": "string",
                                                  "enum": [
                                                    "eq",
                                                    "neq",
                                                    "gt",
                                                    "gte",
                                                    "lt",
                                                    "lte",
                                                    "exists",
                                                    "not_exists",
                                                    "non_empty",
                                                    "contains",
                                                    "starts_with",
                                                    "ends_with",
                                                    "in",
                                                    "not_in"
                                                  ]
                                                },
                                                "value": {
                                                  "anyOf": [
                                                    {
                                                      "type": "string",
                                                      "maxLength": 500
                                                    },
                                                    {
                                                      "type": "number"
                                                    },
                                                    {
                                                      "type": "boolean"
                                                    },
                                                    {
                                                      "type": "null"
                                                    },
                                                    {
                                                      "type": "array",
                                                      "items": {
                                                        "anyOf": [
                                                          {
                                                            "type": "string",
                                                            "maxLength": 500
                                                          },
                                                          {
                                                            "type": "number"
                                                          },
                                                          {
                                                            "type": "boolean"
                                                          },
                                                          {
                                                            "type": "null"
                                                          }
                                                        ]
                                                      },
                                                      "maxItems": 50
                                                    }
                                                  ]
                                                }
                                              },
                                              "required": [
                                                "field",
                                                "op"
                                              ]
                                            },
                                            {
                                              "type": "object",
                                              "properties": {
                                                "all": {
                                                  "type": "array",
                                                  "items": {
                                                    "type": "object",
                                                    "properties": {
                                                      "field": {
                                                        "type": "string",
                                                        "maxLength": 120,
                                                        "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                      },
                                                      "op": {
                                                        "type": "string",
                                                        "enum": [
                                                          "eq",
                                                          "neq",
                                                          "gt",
                                                          "gte",
                                                          "lt",
                                                          "lte",
                                                          "exists",
                                                          "not_exists",
                                                          "non_empty",
                                                          "contains",
                                                          "starts_with",
                                                          "ends_with",
                                                          "in",
                                                          "not_in"
                                                        ]
                                                      },
                                                      "value": {
                                                        "anyOf": [
                                                          {
                                                            "type": "string",
                                                            "maxLength": 500
                                                          },
                                                          {
                                                            "type": "number"
                                                          },
                                                          {
                                                            "type": "boolean"
                                                          },
                                                          {
                                                            "type": "null"
                                                          },
                                                          {
                                                            "type": "array",
                                                            "items": {
                                                              "anyOf": [
                                                                {
                                                                  "type": "string",
                                                                  "maxLength": 500
                                                                },
                                                                {
                                                                  "type": "number"
                                                                },
                                                                {
                                                                  "type": "boolean"
                                                                },
                                                                {
                                                                  "type": "null"
                                                                }
                                                              ]
                                                            },
                                                            "maxItems": 50
                                                          }
                                                        ]
                                                      }
                                                    },
                                                    "required": [
                                                      "field",
                                                      "op"
                                                    ]
                                                  },
                                                  "minItems": 1,
                                                  "maxItems": 20
                                                }
                                              },
                                              "required": [
                                                "all"
                                              ]
                                            },
                                            {
                                              "type": "object",
                                              "properties": {
                                                "any": {
                                                  "type": "array",
                                                  "items": {
                                                    "type": "object",
                                                    "properties": {
                                                      "field": {
                                                        "type": "string",
                                                        "maxLength": 120,
                                                        "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                      },
                                                      "op": {
                                                        "type": "string",
                                                        "enum": [
                                                          "eq",
                                                          "neq",
                                                          "gt",
                                                          "gte",
                                                          "lt",
                                                          "lte",
                                                          "exists",
                                                          "not_exists",
                                                          "non_empty",
                                                          "contains",
                                                          "starts_with",
                                                          "ends_with",
                                                          "in",
                                                          "not_in"
                                                        ]
                                                      },
                                                      "value": {
                                                        "anyOf": [
                                                          {
                                                            "type": "string",
                                                            "maxLength": 500
                                                          },
                                                          {
                                                            "type": "number"
                                                          },
                                                          {
                                                            "type": "boolean"
                                                          },
                                                          {
                                                            "type": "null"
                                                          },
                                                          {
                                                            "type": "array",
                                                            "items": {
                                                              "anyOf": [
                                                                {
                                                                  "type": "string",
                                                                  "maxLength": 500
                                                                },
                                                                {
                                                                  "type": "number"
                                                                },
                                                                {
                                                                  "type": "boolean"
                                                                },
                                                                {
                                                                  "type": "null"
                                                                }
                                                              ]
                                                            },
                                                            "maxItems": 50
                                                          }
                                                        ]
                                                      }
                                                    },
                                                    "required": [
                                                      "field",
                                                      "op"
                                                    ]
                                                  },
                                                  "minItems": 1,
                                                  "maxItems": 20
                                                }
                                              },
                                              "required": [
                                                "any"
                                              ]
                                            },
                                            {
                                              "type": "object",
                                              "properties": {
                                                "not": {
                                                  "type": "object",
                                                  "properties": {
                                                    "field": {
                                                      "type": "string",
                                                      "maxLength": 120,
                                                      "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                                    },
                                                    "op": {
                                                      "type": "string",
                                                      "enum": [
                                                        "eq",
                                                        "neq",
                                                        "gt",
                                                        "gte",
                                                        "lt",
                                                        "lte",
                                                        "exists",
                                                        "not_exists",
                                                        "non_empty",
                                                        "contains",
                                                        "starts_with",
                                                        "ends_with",
                                                        "in",
                                                        "not_in"
                                                      ]
                                                    },
                                                    "value": {
                                                      "anyOf": [
                                                        {
                                                          "type": "string",
                                                          "maxLength": 500
                                                        },
                                                        {
                                                          "type": "number"
                                                        },
                                                        {
                                                          "type": "boolean"
                                                        },
                                                        {
                                                          "type": "null"
                                                        },
                                                        {
                                                          "type": "array",
                                                          "items": {
                                                            "anyOf": [
                                                              {
                                                                "type": "string",
                                                                "maxLength": 500
                                                              },
                                                              {
                                                                "type": "number"
                                                              },
                                                              {
                                                                "type": "boolean"
                                                              },
                                                              {
                                                                "type": "null"
                                                              }
                                                            ]
                                                          },
                                                          "maxItems": 50
                                                        }
                                                      ]
                                                    }
                                                  },
                                                  "required": [
                                                    "field",
                                                    "op"
                                                  ]
                                                }
                                              },
                                              "required": [
                                                "not"
                                              ]
                                            }
                                          ]
                                        }
                                      },
                                      "required": [
                                        "not"
                                      ]
                                    }
                                  ]
                                }
                              },
                              "required": [
                                "type",
                                "endpoint_id"
                              ]
                            },
                            {
                              "type": "object",
                              "properties": {
                                "type": {
                                  "type": "string",
                                  "enum": [
                                    "routed"
                                  ]
                                },
                                "provider": {
                                  "type": "object",
                                  "properties": {
                                    "order": {
                                      "type": "array",
                                      "items": {
                                        "type": "string"
                                      },
                                      "maxItems": 20
                                    },
                                    "only": {
                                      "type": "array",
                                      "items": {
                                        "type": "string"
                                      },
                                      "maxItems": 20
                                    },
                                    "ignore": {
                                      "type": "array",
                                      "items": {
                                        "type": "string"
                                      },
                                      "maxItems": 20
                                    },
                                    "allow_fallbacks": {
                                      "type": "boolean"
                                    },
                                    "sort": {
                                      "type": "string",
                                      "enum": [
                                        "price",
                                        "reliability",
                                        "latency",
                                        "throughput",
                                        "quality"
                                      ]
                                    },
                                    "max_cost_micro": {
                                      "type": "integer",
                                      "minimum": 0,
                                      "description": "Skip endpoints whose quote exceeds this"
                                    },
                                    "max_price_micro": {
                                      "type": "integer",
                                      "minimum": 0,
                                      "description": "OpenRouter-style max_price: skip endpoints whose worst-case price is above this"
                                    },
                                    "preferred_max_latency_ms": {
                                      "type": "integer",
                                      "exclusiveMinimum": 0,
                                      "maximum": 120000,
                                      "description": "Endpoints with a p50 above this are tried after the ones under it"
                                    },
                                    "data_policy": {
                                      "type": "object",
                                      "properties": {
                                        "storage": {
                                          "type": "string",
                                          "enum": [
                                            "any",
                                            "reviewed",
                                            "storable"
                                          ],
                                          "default": "any"
                                        },
                                        "zdr": {
                                          "type": "boolean",
                                          "default": false
                                        }
                                      }
                                    },
                                    "require_verified": {
                                      "type": "boolean",
                                      "description": "Only vendors Relaygrid has verified"
                                    }
                                  },
                                  "default": {}
                                },
                                "max_endpoints": {
                                  "type": "integer",
                                  "minimum": 1,
                                  "maximum": 20,
                                  "default": 5
                                },
                                "id": {
                                  "type": "string",
                                  "minLength": 1,
                                  "maxLength": 40,
                                  "pattern": "^[a-z0-9][a-z0-9_-]*$",
                                  "description": "Stable id; defaults to the endpoint id"
                                },
                                "timeout_ms": {
                                  "type": "integer",
                                  "minimum": 100,
                                  "maximum": 120000
                                },
                                "retries": {
                                  "type": "integer",
                                  "minimum": 0,
                                  "maximum": 5,
                                  "default": 0,
                                  "description": "Retries on 5xx and timeouts"
                                },
                                "retry_backoff_ms": {
                                  "type": "integer",
                                  "minimum": 0,
                                  "maximum": 30000,
                                  "default": 250
                                },
                                "max_cost_micro": {
                                  "type": "integer",
                                  "minimum": 0,
                                  "description": "Skip this step if its quote is above this"
                                },
                                "required_fields": {
                                  "type": "array",
                                  "items": {
                                    "type": "string",
                                    "maxLength": 80,
                                    "pattern": "^[a-z][a-z0-9_]*(\\.[a-z][a-z0-9_]*)*$"
                                  },
                                  "maxItems": 20,
                                  "default": []
                                },
                                "min_confidence": {
                                  "type": "number",
                                  "minimum": 0,
                                  "maximum": 100
                                },
                                "confidence_field": {
                                  "type": "string",
                                  "maxLength": 80,
                                  "pattern": "^[a-z][a-z0-9_]*(\\.[a-z][a-z0-9_]*)*$",
                                  "default": "confidence"
                                },
                                "prefer_verified": {
                                  "type": "boolean",
                                  "default": false
                                },
                                "continue_on_hit": {
                                  "type": "boolean",
                                  "default": false
                                },
                                "credential": {
                                  "type": "string",
                                  "enum": [
                                    "auto",
                                    "managed",
                                    "byok"
                                  ],
                                  "default": "auto"
                                },
                                "on_client_error": {
                                  "type": "string",
                                  "enum": [
                                    "continue",
                                    "fail"
                                  ],
                                  "default": "continue"
                                },
                                "when": {
                                  "anyOf": [
                                    {
                                      "type": "object",
                                      "properties": {
                                        "field": {
                                          "type": "string",
                                          "maxLength": 120,
                                          "pattern": "^[a-z_][a-z0-9_]*(\\.[a-z0-9_]+)*$"
                                        },
                                        "op": {
                                          "type": "string",
                                          "enum": [
                                            "eq",
                                            "neq",
                                            "gt",
                                            "gte",
                                            "lt",
                                            "lte",
                                            "exists",
                                            "not_exists",
[...]
